@Filename: GetChar.s
@Part: ADuC702x.
@Created: 20/04/2004
@Updated: 28/06/2005
@Author: Eckart Hartmann.
@This file is in beta sampling.

.include        "ADuC7020.equ"
.ARM
@ getchar==========Reads the UART data register.
@ C Function prototype: int getchar(void);
@ Description of Function: Waits for character from UART then returns it.
@ User interface:
@   Call getkey.
@   Returns COMRX when available:
@ Robustness:  Waits until character available.
@ Side effects: Corrupts r3.


.GLOBAL getchar
getchar:
        mov     r3,#0xff0000            @r3 = Z_BASE;
        orr     r3,r3,#0xff000000
GkLoop: ldr     r0,[r3,#COMSTA0_OFFSET] @Loop till data ready.
        ands    r0,r0,#0x01             
        beq     GkLoop
        ldrb    r0,[r3,#COMRX_OFFSET]   @Get COMRX.
        bx      lr                      @return.
